import de.pakad.tools.StdIn;
import de.pakad.tools.StdOut;

/**
 * Demonstration des ternren Operators,
 *
 * <p>Berechnung der <span class="small-caps">Collatz</span>-Funktion
 * und der Anzahl der Iterationen, die bentigt werden, um eine
 * Eingabezahl auf den Wert 1 zu transformieren.</p>
 *
 * @author Karsten Brodmann
 * @see Collatz
 */
public class Ternary {
    /**
     * @param args nicht verwendet
     */
    public static void main(String[] args) {
        /* Definiere zwei Variablen x und z vom Typ "ganze Zahl"
         *
         *    x = Eingabe-/Startzahl
         *    z = Zhlvariable
         */
        int x = StdIn.readInt("Bitte eine natrliche Zahl: ");
        int z = 0;

        while (x > 1) {       // solange x grer 1 ...
            /* Wenn x ganzzahling ohne Rest durch 2 teilbar, also gerade, ist
             * -> dann halbiere x
             * -> anderfalls verdreifache x und addiere 1
             */
            x = x%2 == 0 ? x/2 : 3*x + 1;
            z = z+1;          // erhhe z um 1
        }
        StdOut.println(z);    // gib z aus
    }
}
